<template>
  <div>
    <!-- disini saya menggunakan bootstrap untuk design tabel nya. secara default bootstrap sudah di include di file welcome.blade.php jadi saya tidak perlu lagi untuk import file nya -->
    <div class="row">
      <div class="col-md-12">
        <br>
        <br>
        <div class="row">
          <div class="col-md-10">
            <h4>Mahasiswa</h4>
          </div>
          <div class="col-md-2">
            <!-- push router ke form membuat data -->
            <router-link class="btn btn-primary w-100" to="/create">+ Tambah</router-link>
          </div>
        </div>
        <br>
        <table class="table">
          <thead>
            <tr>
              <th scope="col">Nim</th>
              <th scope="col">Nama</th>
              <th scope="col">Jurusan</th>
              <th scope="col">Email</th>
              <th scope="col">Action</th>
            </tr>
          </thead>
          <tbody>
            <!-- menampilkan data ke table -->
            <tr v-for="mahasiswa in mahasiswa" :key="mahasiswa.id">
              <td style="width:20%">{{mahasiswa.nim}}</td>
              <td style="width:20%">{{mahasiswa.nama}}</td>
              <td style="width:20%">{{mahasiswa.jurusan}}</td>
              <td style="width:20%">{{mahasiswa.email}}</td>
              <td style="width:20%">
                <router-link class="btn btn-warning" :to="'/detail/'+mahasiswa.id">Update</router-link>
                <button class="btn btn-danger" v-on:click="deleteData(mahasiswa.id)">Delete</button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<!-- script js -->
<script>
export default {
  data() {
    return {
      // variable array yang akan menampung hasil fetch dari api
      mahasiswa: []
    };
  },
  created() {
    this.loadData();
  },
  methods: {
    loadData() {
      // fetch data dari api menggunakan axios
      axios.get("http://localhost:8000/api/mahasiswa").then(response => {
        // mengirim data hasil fetch ke varibale array persons
        this.mahasiswa = response.data;
      });
    },
    deleteData(id) {
      // alert auth
      this.$swal.fire({
      title: 'Apakah kamu yakin?',
      text: "Jika kamu hapus, maka data tidak akan kembali lagi.",
      icon: 'warning',
      showCancelButton: true,
      confirmButtonColor: '#3085d6',
      cancelButtonColor: '#d33',
      confirmButtonText: 'Hapus Deh',
      cancelButtonText: 'Nggak Jadi'
      }).then((result) => {
        if (result.value) {
          this.$swal.fire({
            title: 'Success!',
            text: 'Mahasiswa deleted successfully',
            icon: 'success',
            timer: 1000
          });
          //delete data
          axios.delete("http://localhost:8000/api/mahasiswa/" + id).then(response => {
          this.loadData();
          });
        }
      })
    }
  }
};
</script>
